<script setup lang="ts">
import salary from '@/services/salary'
import { useCheckInStore } from '@/stores/checkIn'
import { useMembersStore } from '@/stores/member'
import { useMessageStore } from '@/stores/message'
import { useSalaryStore } from '@/stores/salary'
import { useUserStore } from '@/stores/user'
import type { CheckIn } from '@/types/CheckIn'
import type { Salary } from '@/types/Salary'
import type { User } from '@/types/User'
import html2canvas from 'html2canvas'
import jsPDF from 'jspdf'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const props = defineProps<{
  user: User
}>()
const emit = defineEmits<{
  selectedUser: [User]
}>()

emit('selectedUser', props.user)

const userStore = useUserStore()
const checkinStore = useCheckInStore()
const salaryStore = useSalaryStore()
const messageStore = useMessageStore()

const History = ref(false)
const Create = ref(false)
const form = ref(false)
const loading = ref(false)
const errorDialog = ref(false)

const salarysById = ref<Salary[]>([])
const checkinssById = ref<CheckIn[]>([])

//////////////////////////////// Main Function /////////////////////////////////////////

async function historyPaid(item: User) {
  if (!item.id) return
  if (nowRole.value === 'Staff') {
    if (item.id != nowId.value) {
      errorDialog.value = true
      return
    }
  }
  await salaryStore.getSalaryByUserId(item.id)
  salarysById.value = salaryStore.salarysByUserId
  History.value = true
}

async function getCheckInsByUserId(item: User) {
  if (!item.id) return
  await checkinStore.getCheckInsyByUserId(item.id)
  checkinssById.value = checkinStore.checkinssById

  for (let i = checkinssById.value.length - 1; i >= 0; i--) {
    if (checkinssById.value[i].status === true) {
      checkinssById.value.splice(i, 1)
    }
  }
}

function savePDF() {
  const receipt = document.getElementById('receipt')
  html2canvas(receipt!).then((canvas) => {
    const imageData = canvas.toDataURL('image/png')
    const pdf = new jsPDF()
    pdf.addImage(imageData, 'PNG', 10, 10, 300, 150)
    pdf.save('receipt.pdf')
  })
}

async function createForm(item: User) {
  if (item.id != null) {
    salaryStore.findSalary(item.id)
    if (item.unpaidHour === 0 || item.unpaidHour === undefined) {
      messageStore.showErrorLogin()
      return
    }
    if (salaryStore.booCheck === true) {
      getCheckInsByUserId(item)
      Create.value = true
    } else if (salaryStore.booCheck === false) {
      await salaryStore.CreateSalary(item)
      getCheckInsByUserId(item)
      Create.value = true
    }
  }
}

async function deleteSalary(user: User) {
  await salaryStore.deleteSalary(user)
  closeDialog()
}

function closeDialog() {
  History.value = false
  Create.value = false
  nextTick(() => {
    salaryStore.clearForm()
  })
}
async function confirmPaid(item: User) {
  await salaryStore.paidUpdate(item)
  closeDialog()
  refreshPage()
}

//////////////////////////////// ETC /////////////////////////////////////////

// function upper1st(str: string | undefined) {
//   if (!str) {
//     return ''
//   }
//   return str.charAt(0).toUpperCase() + str.slice(1)
// }

const sta = ref(false)

// function shouldShowItem(item: CheckIn, user: User) {
//   if (item.user.id === user.id) {
//     sta.value = true
//   }
//   return sta.value, (sta.value = false)
// }

function closeError() {
  errorDialog.value = false
}

function checkAdminOrUser() {
  if (nowRole.value == 'Manager' || nowRole.value == 'Owner') {
    isAdmin.value = true
  } else if (nowRole.value == 'Staff') {
    isAdmin.value = false
  }
}

function refreshPage() {
  window.location.reload()
}

// function refreshPage() {
//   window.location.reload()
// }

const status = ref(false)
const isAdmin = ref(true)
const nowRole = ref('')
const nowId = ref(0)

onMounted(async () => {
  await checkinStore.getCheckIns()
  await userStore.getUsers()
  const strUser = localStorage.getItem('user')
  try {
    if (strUser) {
      const parsedUser = JSON.parse(strUser)
      nowRole.value = parsedUser.role
      nowId.value = parsedUser.id
      checkAdminOrUser()
    }
  } catch (error) {
    console.error('Error parsing user data:', error)
  }
})
</script>
<template>
  <v-table :items="userStore.users">
    <v-card class="mx-4 my-12" max-width="600" color="white">
      <v-img cover height="280" :src="'http://localhost:3000/images/users/' + user.image"></v-img>
      <v-card-item class="user-id">
        <h class="user-id-circle">{{ user.id }}</h>
        <v-card-title style="font-size: 25px">{{ user.fullName }}</v-card-title>
      </v-card-item>
      <v-card-text>
        <v-divider class="mx-4 mb-1"></v-divider>
        <div class="my-4 text-subtitle-1">Type: {{ user.workType }}</div>
        <div class="my-4 text-subtitle-1">
          Unpaid Work:
          {{
            user.unpaidHour !== undefined && user.unpaidHour !== 0
              ? user.unpaidHour + ' Hour'
              : '0' + ' Hour'
          }}
        </div>
        <div class="my-4 text-subtitle-1">
          Worked Unpaid:
          {{
            user.paidedHour !== undefined && user.paidedHour !== 0
              ? user.paidedHour + ' Hour'
              : '0' + ' Hour'
          }}
        </div>

        <div class="my-4 text-subtitle-1">
          Status:
          <span :class="{ 'text-green': user.status, 'text-blue': !user.status }">
            {{ user.status ? 'No Need ' : 'Need Paid' }}
            <v-icon v-if="status">mdi-check-circle</v-icon>
            <v-icon v-else>mdi-alert-circle</v-icon>
          </span>
        </div>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-icon class="me-3 , btn-circle" v-model="History" @click="historyPaid(user)"
            >mdi-history</v-icon
          >
          <v-icon v-if="isAdmin" v-model="Create" @click="createForm(user)" class="btn-circle-paid">
            mdi-cash
          </v-icon>
        </v-card-actions>
      </v-card-text>
    </v-card>
  </v-table>

  <v-dialog v-model="History" persistent width="500" :items="userStore.users">
    <v-card>
      <!-- Header -->
      <v-toolbar color="primary" dark>
        <v-toolbar-title class="text-h5">Salary Payment History</v-toolbar-title>
      </v-toolbar>

      <!-- Information in top left -->
      <v-card-text class="info-section">
        <!-- Your information goes here -->
      </v-card-text>

      <!-- Scrolling text view -->
      <v-card-text class="scrolling-text">
        <v-card-text v-for="(item, index) in salarysById" :key="index" readonly auto-grow rows="1"
          ><div id="receipt">
            Paid By : {{ item.managerId }} <br />
            Total Hour : {{ item.totalHour }} Hour <br />
            PaymentMethod : {{ item.paymentMethod }} <br />
            Total Price : {{ item.totalPrice }} Bath<br />
            Pay Date : {{ item.payDate }} <br />
            Status:
            <span v-if="item.status !== false" style="color: green">Done</span>
            <span v-else style="color: red">Undone</span>
            <br /><br />
          </div>
          <v-btn color="primary" height="25px" @click="savePDF()">PDF</v-btn>
          <p>---------------------------------------------------------------</p>
        </v-card-text>
      </v-card-text>

      <!-- Actions -->
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="red" variant="text" @click="closeDialog()">Close</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="Create" persistent width="800" height="700" color="grey" style="z-index: 1">
    <v-card height="600" style="top: 60px">
      <v-card-title>
        <span class="text-h5">User</span>
      </v-card-title>
      <v-card-text class="scrolling-text">
        <v-card-text v-for="(item, index) in checkinssById" :key="index" readonly auto-grow rows="1"
          >Date : {{ item.date }} <br />
          Hour : {{ item.hour }} Hour <br />
          User : {{ item.user.fullName }} <br />
          Status:
          <span v-if="item.status !== false" style="color: green">Done</span>
          <span v-else style="color: red">Undone</span>
          <br />
          <div>--------------------------------------------------</div>
        </v-card-text>
      </v-card-text>
      <v-card-text>
        <v-form ref="refform" v-model="form" @submit.prevent="">
          <v-container>
            <v-row>
              <v-col cols="6" sm="6" md="6">
                <v-combobox
                  v-model="salaryStore.editedSalary.paymentMethod"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  :items="[
                    { title: 'Cash', value: 'Cash' },
                    { title: 'Credit Card', value: 'Credit Card' },
                    { title: 'Banking', value: 'Banking' }
                  ]"
                  label="workType"
                  :return-object="false"
                ></v-combobox>
              </v-col>
              <v-col cols="6" sm="6" md="6">
                <v-card-text style="font-size: 20px">
                  Total Hours : {{ salaryStore.editedSalary.user?.unpaidHour! }} Hour <br /><br />
                  Total Workrate : {{ salaryStore.editedSalary.user?.workRate! }} Baht <br /><br />
                  Total Price :
                  {{
                    salaryStore.editedSalary.user?.unpaidHour! *
                    salaryStore.editedSalary.user?.workRate!
                  }}
                  Baht
                </v-card-text>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small style="color: red">*Please fill data</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" @click="deleteSalary(user)"> Delete Form </v-btn>
        <v-btn color="primary" variant="text" @click="confirmPaid(user)"> Paid </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="messageStore.errorDialog" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Paid Fail</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        Employee need to have Unpaid Work <br />
        to create salary.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="messageStore.closeErrorLogin()">
            Cancel
          </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>

  <v-dialog v-model="errorDialog" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">History Failed to open</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        You don't have permission to <br />
        view this page.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeError()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
</template>

<style scoped>
.user-id {
  display: flex;
  align-items: center; /* Center align items vertically */
}

.user-id .v-card-title {
  margin-right: 10px; /* Add some space between the circle and the name */
}

.user-id .user-id-circle {
  background-color: orangered; /* Change circle background color */
  color: white; /* Change circle text color */
  font-weight: bold; /* Apply bold font weight to circle text */
  width: 30px; /* Set circle width */
  height: 30px; /* Set circle height */
  border-radius: 50%; /* Make it a circle */
  display: flex;
  justify-content: center; /* Center align text horizontally */
  align-items: center; /* Center align text vertically */
}

.btn-circle {
  background-color: orangered; /* Change circle background color */
  color: white; /* Change circle text color */
  font-weight: bold; /* Apply bold font weight to circle text */
  width: 30px; /* Set circle width */
  height: 30px; /* Set circle height */
  border-radius: 50%; /* Make it a circle */
  display: flex;
  justify-content: center; /* Center align text horizontally */
  align-items: center; /* Center align text vertically */
}

.btn-circle-paid {
  background-color: green; /* Change circle background color */
  color: white; /* Change circle text color */
  font-weight: bold; /* Apply bold font weight to circle text */
  width: 30px; /* Set circle width */
  height: 30px; /* Set circle height */
  border-radius: 50%; /* Make it a circle */
  display: flex;
  justify-content: center; /* Center align text horizontally */
  align-items: center; /* Center align text vertically */
}

.text-green {
  color: green;
}

.text-blue {
  color: #009fff;
}

.info-section {
  /* Styling for the information section */
  /* Example: */
  position: absolute;
  top: 20px;
  left: 20px;
}

.scrolling-text {
  /* Styling for the scrolling text view */
  /* Example: */
  max-height: 300px;
  overflow-y: auto;
}
</style>
